'************************************************
'* MultiModem Demo Application - CreateMessageForm
'* Environment: Visual Basic 2005
'* Programmer: Sam Javner
'* Date: 4/29/2007
'*
'* Summary: Used to create and send a message.
'* Form is displayed from uxCreateButton_Click() in MainForm
'************************************************


Public Class CreateMessageForm



    '************************************************
    '* Private Sub CreateMessageForm_Load
    '* Summary:     Occurs when form is loaded, set default SMS mode to text mode
    '************************************************
    Private Sub CreateMessageForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        uxText.Checked = True

    End Sub



    '************************************************
    '* Private Sub uxText_Click
    '* Summary:     Occurs when text radio button is clicked
    '*              Set maximum length to 160 characters
    '************************************************
    Private Sub uxText_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles uxText.Click

        If Len(uxSMS.Text) > 160 Then uxSMS.Text = Microsoft.VisualBasic.Left(uxSMS.Text, 160)
        uxSMS.MaxLength = 160

    End Sub



    '************************************************
    '* Private Sub uxHex7_Click
    '* Summary:     Occurs when hex 7-bit radio button is clicked
    '*              Set maximum length to 320 characters
    '*              (160 x 2 bytes per hex representation of a character)
    '************************************************
    Private Sub uxHex7_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles uxHex7.Click

        If Len(uxSMS.Text) > 320 Then uxSMS.Text = Microsoft.VisualBasic.Left(uxSMS.Text, 320)
        uxSMS.MaxLength = 320

    End Sub



    '************************************************
    '* Private Sub uxHex8_Click
    '* Summary:     Occurs when hex 8-bit radio button is clicked
    '*              Set maximum length to 280 characters
    '*              (140 x 2 bytes per hex representation of a character)
    '************************************************
    Private Sub uxHex8_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles uxHex8.Click

        If Len(uxSMS.Text) > 280 Then uxSMS.Text = Microsoft.VisualBasic.Left(uxSMS.Text, 280)
        uxSMS.MaxLength = 280

    End Sub



    '************************************************
    '* Private Sub uxSendButton_Click()
    '* Summary:     Attempts to send the message.
    '************************************************
    Private Sub uxSendButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles uxSendButton.Click

        Dim number As String
        Dim msg As String

        'Remove dashes from the phone number
        number = uxToValue.Text
        While InStr(number, "-") > 0
            number = Microsoft.VisualBasic.Left(number, InStr(number, "-") - 1) & Mid(number, InStr(number, "-") + 1)
        End While

        If Len(number) = 0 Then
            MsgBox("To field must not be blank", vbExclamation, "MultiModem Demo Application")
            Exit Sub
        End If

        msg = uxSMS.Text

        If uxText.Checked = True Then

            'Set text mode
            If Not MainForm.MM.SetCharacterSet("PCCP437") Then
                MsgBox("Error setting character set", vbExclamation, "MultiModem Demo Application")
                Exit Sub
            End If

            'Send text mode message
            If MainForm.MM.SendMessage(number, msg) Then
                Me.Close()
            Else
                MsgBox("Error sending message", vbExclamation, "MultiModem Demo Application")
                Exit Sub
            End If

        ElseIf uxHex7.Checked = True Then

            'Set hex mode
            If Not MainForm.MM.SetCharacterSet("HEX") Then
                MsgBox("Error setting character set", vbExclamation, "MultiModem Demo Application")
                Exit Sub
            End If

            'Send text mode message (with hex representation)
            If MainForm.MM.SendMessage(number, msg) Then
                Me.Close()
            Else
                MsgBox("Error sending message", vbExclamation, "MultiModem Demo Application")
            End If

        ElseIf uxHex8.Checked = True Then

            'Send PDU mode message
            If MainForm.MM.SendMessageTPDU(number, msg) Then
                Me.Close()
            Else
                MsgBox("Error sending message", vbExclamation, "MultiModem Demo Application")
            End If

        End If

        Me.Close()

    End Sub


End Class